Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* aisa38w.bas
'*
'* aISA-R38
'*
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'* Date 1998/05/27
'*
'*****************************************************************************
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const AISA38_DLL_NAME = "aisa38.dll"  ' DLLt@C
Global Const AISA38_ERR_WRAPDLL = -1        ' bp[֐G[

Dim hDLL As Long                'DLLւ̃nh

'*****************************************************************************
'* @\     aisa38.dll[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa38wDllOpen() As Boolean

    Aisa38wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    hDLL = LoadLibrary(AISA38_DLL_NAME)
    
    If hDLL = 0 Then Exit Function
    
    If Aisa38wGetDllExportFunc() = False Then
        Aisa38wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If
    
    Aisa38wDllOpen = True

End Function

'*****************************************************************************
'* @\     aisa38.dllA[h
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Function Aisa38wDllClose() As Boolean
    
    If hDLL = 0 Then
        Aisa38wDllClose = True
        Exit Function
    End If
    
    If FreeLibrary(hDLL) <> 0 Then
        hDLL = 0
        Aisa38wDllClose = True
        Exit Function
    End If
    
    Aisa38wDllClose = False

End Function

'*****************************************************************************
'* @\     aISA-R38 DLL,Driver̃o[Wԍ擾
'*      pdwDllVer --- DLLo[Wԍi[
'*          pdwDrvVer --- Drivero[Wԍi[
'* ߂l   True          --- 
'*          False         --- s
'*****************************************************************************
Function Aisa38wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean
    
    If hDLL = 0 Then
        Aisa38wGetVersion = 0
        Exit Function
    End If
    
    If Aisa38GetVersion(pdwDllVer, pdwDrvVer) <> 0 Then
        Aisa38wGetVersion = True
    Else
        Aisa38wGetVersion = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-R38̔Cӂ̃foCX̎gp錾
'*      pwLogSlot --- gpfoCXi[AhX
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa38wCreate(pwLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa38wCreate = False
        Exit Function
    End If
    
    If Aisa38Create(pwLogSlot) <> 0 Then
        Aisa38wCreate = True
    Else
        Aisa38wCreate = False
    End If

End Function

'*****************************************************************************
'* @\     aISA-R38̔Cӂ̃foCX̎gpJ
'*      wLogSlot --- gpfoCX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa38wClose(wLogSlot As Integer) As Boolean
    
    If hDLL = 0 Then
        Aisa38wClose = False
        Exit Function
    End If
    
    If Aisa38Close(wLogSlot) <> 0 Then
        Aisa38wClose = True
    Else
        Aisa38wClose = False
    End If

End Function

'*****************************************************************************
'* @\     wfoCX̃\[X擾
'*      wLogSlot --- ׂfoCX
'*          pResInfo --- \[Xi[\̂̃AhX
'* ߂l   True     --- 
'*          False    --- s
'*****************************************************************************
Function Aisa38wGetResource(wLogSlot As Integer, pResInfo As AISA38RESOURCE) As Boolean
    
    If hDLL = 0 Then
        Aisa38wGetResource = False
        Exit Function
    End If
    
    If Aisa38GetResource(wLogSlot, pResInfo) <> 0 Then
        Aisa38wGetResource = True
    Else
        Aisa38wGetResource = False
    End If

End Function

'*****************************************************************************
'* @\     Cӂ̃|[gփf[^o
'*      wLogSlot  --- o͂foCX
'*          dwPort    --- o͂|[g
'*          bOutValue --- o͂f[^
'* ߂l   True      --- 
'*          False     --- s
'*****************************************************************************
Function Aisa38wOutPort(wLogSlot As Integer, dwPort As Long, bOutValue As Byte) As Boolean
    
    If hDLL = 0 Then
        Aisa38wOutPort = False
        Exit Function
    End If
    
    If Aisa38OutPort(wLogSlot, dwPort, bOutValue) <> 0 Then
        Aisa38wOutPort = True
    Else
        Aisa38wOutPort = False
    End If

End Function

'*****************************************************************************
'* @\      aISA-R38̃G[R[h𓾂
'*       wLogSlot --- G[foCX
'* ߂l             --- G[R[h
'*****************************************************************************
Function Aisa38wGetLastError(wLogSlot As Integer) As Long
    
    If hDLL = 0 Then
        Aisa38wGetLastError = AISA38_ERR_WRAPDLL
        Exit Function
    End If
    
    Aisa38wGetLastError = Aisa38GetLastError(wLogSlot)

End Function

'*****************************************************************************
'* @\     DLLGNX|[g֐L̊mF
'*      Ȃ
'* ߂l   True  --- 
'*          False --- s
'*****************************************************************************
Private Function Aisa38wGetDllExportFunc() As Boolean
    
    Dim pFunc As Long
    
    Aisa38wGetDllExportFunc = False
    
    ' Aisa38GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa38GetVersion")
    If pFunc = 0 Then Exit Function
          
    ' Aisa38Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa38Create")
    If pFunc = 0 Then Exit Function
          
    ' Aisa38Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa38Close")
    If pFunc = 0 Then Exit Function

    ' Aisa38GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa38GetResource")
    If pFunc = 0 Then Exit Function

    ' Aisa38OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa38OutPort")
    If pFunc = 0 Then Exit Function

    ' Aisa38GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Aisa38GetLastError")
    If pFunc = 0 Then Exit Function

    Aisa38wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF

End Function
