#ifndef _AisaR38_H_
#define _AisaR38_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AISA38_MAX_SLOTS 	16
#define	AISA38_SLOT_AUTO	((WORD) ~0U)
#define	AISA38_PORT_0		0
#define	AISA38_PORT_1		1
#define	AISA38_PORT_2		2
#define	AISA38_PORT_3		3

// G[R[h
#define AISA38_SUCCESS				0	// ُȂ
#define AISA38_ERR_SYSTEM			1	// GetLastError sĂ
#define AISA38_ERR_NO_DEVICE		2	// gp\ȃfoCXȂ
#define AISA38_ERR_IN_USE			3	// w肳ꂽXbg͎gp
#define AISA38_ERR_INVALID_SLOT		4	// Ș_Xbgԍ
#define AISA38_ERR_RESOURCE			5	// \[XG[
#define AISA38_ERR_INVALID_PORT		6	// ȃ|[gԍ
#define AISA38_ERR_INVALID_ARGUMENT	7	// Ȉ

#define AISA38_MAX_MEM		9
#define AISA38_MAX_IO		20
#define AISA38_MAX_IRQ		7
#define AISA38_MAX_DMA		7

//======================================================================
// \[X\
//======================================================================
typedef struct {
	DWORD	dwNumMemWindows;                   // EChE	gp
	DWORD	dwMemBase		[AISA38_MAX_MEM];  // MWx[XAhX		gp
	DWORD	dwMemLength		[AISA38_MAX_MEM];  // MW					gp
	DWORD	dwMemAttrib		[AISA38_MAX_MEM];  // MW				gp
	DWORD	dwNumIOPorts;                      // I/O|[g
	DWORD	dwIOPortBase	[AISA38_MAX_IO];   // I/O|[gx[XAhX
	DWORD	dwIOPortLength	[AISA38_MAX_IO];   // I/O|[g
	DWORD	dwNumIRQs;                         // IRQ					gp
	DWORD	dwIRQRegisters	[AISA38_MAX_IRQ];  // IRQXg				gp
	DWORD	dwIRQAttrib		[AISA38_MAX_IRQ];  // IRQXg			gp
	DWORD	dwNumDMAs;                         // DMA`l			gp
	DWORD	dwDMALst		[AISA38_MAX_DMA];  // DMA`lXg		gp
	DWORD	dwDMAAttrib		[AISA38_MAX_DMA];  // DMA`lXg	gp
	DWORD	dwReserved1		[3];               // \					gp
} AISA38RESOURCE;

typedef		AISA38RESOURCE *PAISA38R;
typedef		AISA38RESOURCE FAR *LPAISA38R;

//-- ȉAPI --
//======================================================================
// VxD  DLL ̃o[W擾
//======================================================================
BOOL WINAPI Aisa38GetVersion(
	PDWORD		pdwDllVer,		// VxD Version
	PDWORD		pdwVxDVer );	// DLL Version
	
//======================================================================
// foCXgp錾
//======================================================================
BOOL WINAPI Aisa38Create(
	PWORD pwLogSlot );			// Xbgԍ( 0`15 or SLOT_AUTO )
	
//======================================================================
// foCXJ
//======================================================================
BOOL WINAPI Aisa38Close(
	WORD wLogSlot );			// Xbgԍ( 0`15 )
	
//======================================================================
// \[X擾
//======================================================================
BOOL WINAPI Aisa38GetResource(
	WORD	wLogSlot,			// Slot
	AISA38RESOURCE *pRes );		// \[X\̂̃|C^
	

//======================================================================
// AEg|[g
//======================================================================
BOOL WINAPI Aisa38OutPort(
	WORD	wLogSlot,			// Slot
	DWORD	dwPort,				// |[gԍ( 0 - 3 )
	BYTE	bValue );			// l
	
//======================================================================
// Ōw肳ꂽXbgŔsꂽG[R[ho
//======================================================================
DWORD WINAPI Aisa38GetLastError(
	WORD	wLogSlot );			// Slot

#ifdef __cplusplus
}
#endif
#endif
