/*****************************************************************************
 *	aisa38w.c
 *
 *	aISA-R38
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "aisa38w.h"	// aISA-R38

//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Aisa38wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa38GetVersion;
static FARPROC pAisa38Create;
static FARPROC pAisa38Close;
static FARPROC pAisa38GetResource;
static FARPROC pAisa38OutPort;
static FARPROC pAisa38GetLastError;

BOOL Aisa38wDllOpen ( void )
/*****************************************************************************
 * @\  aisa38.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AISA38_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Aisa38wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Aisa38wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Aisa38wDllClose ( void )
/*****************************************************************************
 * @\  aisa38.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Aisa38wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  aISA-R38DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa38GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Aisa38wCreate ( PWORD pwLogSlot )
/*****************************************************************************
 * @\  aISA-R38̔Cӂ̃foCX̎gp錾
 * 	 pwLogSlot	--- gpfoCXi[AhX
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa38Create)(pwLogSlot);
}

BOOL Aisa38wClose ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-R38̔Cӂ̃foCX̎gpJ
 * 	 wLogSlot  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa38Close)(wLogSlot);
}

BOOL Aisa38wGetResource ( WORD wLogSlot, PAISA38R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSlot --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa38GetResource)(wLogSlot, pResInfo);
}

BOOL Aisa38wOutPort ( WORD wLogSlot, DWORD dwPort, BYTE bOutValue )
/*****************************************************************************
 * @\  Cӂ̃|[gփf[^o
 * 	 wLogSlot  --- o͂foCX
 *		 dwPort	   --- o͂|[g
 *		 bOutValue --- o̓f[^
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa38OutPort)(wLogSlot, dwPort, bOutValue);
}

DWORD Aisa38wGetLastError ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-R38̃G[R[h
 * 	 wLogSlot  --- G[foCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AISA38_ERR_WRAPDLL;
	}
	return (*pAisa38GetLastError)(wLogSlot);
}

static BOOL Aisa38wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Aisa38GetVersion ̃AhX擾
	pAisa38GetVersion = GetProcAddress(hDLL, _T("Aisa38GetVersion"));
	if (pAisa38GetVersion == NULL) {
		return FALSE;
	}

	// Aisa38Create ̃AhX擾
	pAisa38Create = GetProcAddress(hDLL, _T("Aisa38Create"));
	if (pAisa38Create == NULL) {
		return FALSE;
	}

	// Aisa38Close ̃AhX擾
	pAisa38Close = GetProcAddress(hDLL, _T("Aisa38Close"));
	if (pAisa38Close == NULL) {
		return FALSE;
	}

	// Aisa38GetResource ̃AhX擾
	pAisa38GetResource = GetProcAddress(hDLL, _T("Aisa38GetResource"));
	if (pAisa38GetResource == NULL) {
		return FALSE;
	}

	// Aisa38OutPort ̃AhX擾
	pAisa38OutPort = GetProcAddress(hDLL, _T("Aisa38OutPort"));
	if (pAisa38OutPort == NULL) {
		return FALSE;
	}

	// Aisa38GetLastError ̃AhX擾
	pAisa38GetLastError = GetProcAddress(hDLL, _T("Aisa38GetLastError"));
	if (pAisa38GetLastError == NULL) {
		return FALSE;
	}
	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
